#include<iom16v.h>
#include<vs1003.h>
#include<data.h>

#define uchar unsigned char
#define uint  unsigned int

//ٶ
void VS1003B_SPI_Low(void)
{
	SPCR =  (1<<SPE)|(1<<MSTR)|(1<<SPR1)|(1<<SPR0);
	SPSR &= ~(1<<SPI2X);
}

//FCK/4ٶ
void VS1003B_SPI_High(void)
{
	SPCR=(1<<SPE)|(1<<MSTR);
	SPSR&= ~(1<<SPI2X);
}
//ʱ
void delay_Nus(unsigned int n)
	{
	unsigned char  b;
		for (b = 1; b<n; b++)
			;
	}
void VS1003B_Delay( unsigned int n)
{
	while(n--);
}

//VS1003дһֽ
unsigned char VS1003B_WriteByte(unsigned char CH)
{   
	SPDR = CH;
	while(!(SPSR & (1<<SPIF)));
	return SPDR;
}

//VS1003һֽ
unsigned char VS1003B_ReadByte()
{
    SPDR = 0xff;
	while(!(SPSR & (1<<SPIF)));
	return SPDR;
}

//дĴַ
void VS1003B_WriteCMD(unsigned char addr, unsigned int dat)
{
	VS1003B_XDCS_H();
	VS1003B_XCS_L();
	VS1003B_WriteByte(0x02);
	//delay_Nus(20);
	VS1003B_WriteByte(addr);
	VS1003B_WriteByte(dat>>8);
	VS1003B_WriteByte(dat);
	//delay_Nus(200);
	VS1003B_XCS_H();
}

//Ĵ ַ 
unsigned int VS1003B_ReadCMD(unsigned char addr)
{
	unsigned int temp;
	unsigned char temp1;
	VS1003B_XDCS_H();
	VS1003B_XCS_L();
	VS1003B_WriteByte(0x03);
	//delay_Nus(20);
	VS1003B_WriteByte(addr);
	temp=  VS1003B_ReadByte();
	temp=temp<<8;
	temp1= VS1003B_ReadByte();
	temp=temp|temp1;;
	VS1003B_XCS_H();
	return temp;
}

//дݣ
void VS1003B_WriteDAT(unsigned char dat)
{
	VS1003B_XDCS_L();
	VS1003B_WriteByte(dat);
	VS1003B_XDCS_H();
	VS1003B_XCS_H();
}

//VS1003ʼ0ɹ 1ʧ
unsigned char VS1003B_Init()
{
	unsigned char retry;
	PORT_INI();
	DDRB|=0xa0;
	VS1003B_DDR &=~(1<<VS1003B_DREQ);
	//delay_Nus(50);
	VS1003B_XCS_H();
	VS1003B_XDCS_H();
	VS1003B_XRESET_L();
	VS1003B_Delay(0xffff);
	VS1003B_XRESET_H();//ʹоƬ
	VS1003B_SPI_Low();//ԵƵ
	VS1003B_Delay(0xffff);//ʱ
	retry=0;
	while(VS1003B_ReadCMD(0x00) != 0x0800)//дmodeĴ
	{
		VS1003B_WriteCMD(0x00,0x0800);
		if(retry++ >10 )break;//{PORTB|=_BV(PB1);break;}
	}
	retry=0;
	/*while(VS1003B_ReadCMD(0x02) != 0x75)//дmodeĴ
	{
		VS1003B_WriteCMD(0x02,0x75);
		if(retry++ >10 )break;//{PORTB|=_BV(PB1);break;}
	}*/
	retry=0;
	while(VS1003B_ReadCMD(0x03) != 0x9800)//дʱӼĴ
	{
		VS1003B_WriteCMD(0x03,0x9800);
		if(retry++ >10 )break;
	}
	retry=0;
	while(VS1003B_ReadCMD(0x0b) != 0x1111)//
	{
		VS1003B_WriteCMD(0x0b,0x1111);
		if(retry++ >10 )break;
	}
	VS1003B_SPI_High();//ٶȣȫ
	if(retry > 10)return 1;
	return 0;
}

//VS1003λ
void VS1003B_SoftReset()
{
	VS1003B_WriteCMD(0x00,0x0804);//дλ
	VS1003B_Delay(0xffff);//ʱ1.35ms
}
void test_1003() 
  {
   unsigned int data_pointer;unsigned char i;
	data_pointer=0; 
    while(data_pointer<4800)
        { 
      if(PINB&0x01)
            {
        for(i=0;i<32;i++)
               {
         VS1003B_WriteDAT(vsBeepMP3[data_pointer]);
         data_pointer++;
                }
		if(data_pointer==4799) break;   //ڵݲˣ
            }
        }
  }   